#include "duoji.h"

pid_param_t pid_x, pid_y;

void Pid_init()
{
	Pid_Inc_Init(&pid_x);//ʽpidʼ
	pid_x.kp = 0.1;
	pid_x.ki = 0.08;
	pid_x.kd = 0.0;
	pid_x.error_deadband = 5.0;
	pid_x.alpha = 0.5;


	Pid_Inc_Init(&pid_y);//ʽpidʼ
	pid_y.kp = 0.1;
	pid_y.ki = 0.08;
	pid_y.kd = 0.0;
	pid_y.error_deadband = 5.0;
	pid_y.alpha = 0.5;

}

float X_ctrl(void)//ٶȻ
{
	float error, output;

	error = vision_point_RED_target.x - vision_point_RED.x;

	output = Pid_Inc(&pid_x, error);

	return output;
}

float Y_ctrl(void)//ٶȻ
{
	float error, output;

	error = vision_point_RED_target.y - vision_point_RED.y;

	output = Pid_Inc(&pid_y, error);

	return output;
}



uint8 run(
	uint8 x0, uint8 y0,
	uint8 x1, uint8 y1,
	uint8 x2, uint8 y2,
	uint8 x3, uint8 y3,
	uint8 x4, uint8 y4,
	uint8* start_flag)
{
	static uint8 flag[10] = { 0 };
	uint8 i = 0;
	static uint8 temp[5][2]={0,0};
	
	if (*start_flag == 1) {

		if (
			x0 != temp[0][0] || y0 != temp[0][1] ||
			x1 != temp[1][0] || y1 != temp[1][1] ||
			x2 != temp[2][0] || y2 != temp[2][1] ||
			x3 != temp[3][0] || y3 != temp[3][1] ||
			x4 != temp[4][0] || y4 != temp[4][1]
			) {
			temp[0][0] = x0; temp[0][1] = y0;
			temp[1][0] = x1; temp[1][1] = y1;
			temp[2][0] = x2; temp[2][1] = y2;
			temp[3][0] = x3; temp[3][1] = y3;
			temp[4][0] = x4; temp[4][1] = y4;

			for (i = 0; i < 10; i++)
			{
				flag[i] = 0;
			}
		}

		if (flag[0] == 0) {
			robot_point_target.x = x0; 
			robot_point_target.y = y0; 
			flag[0] = 1;
		}
		else if (flag[0] == 1 && flag[1] == 0 && calculate_distance(robot_point_real, robot_point_target)<=0.1) {
			robot_point_target.x = x1;
			robot_point_target.y = y1;
			flag[1] = 1;
		}
		else if (flag[1] == 1 && flag[2] == 0 && calculate_distance(robot_point_real, robot_point_target)<=0.1) {
			robot_point_target.x = x2;
			robot_point_target.y = y2;
			flag[2] = 1;
		}
		else if (flag[2] == 1 && flag[3] == 0 && calculate_distance(robot_point_real, robot_point_target)<=0.1) {
			robot_point_target.x = x3;
			robot_point_target.y = y3;
			flag[3] = 1;
		}
		else if (flag[3] == 1 && flag[4] == 0 && calculate_distance(robot_point_real, robot_point_target)<=0.1) {
			robot_point_target.x = x4;
			robot_point_target.y = y4;
			flag[4] = 1;
		}
		else if (flag[4] == 1 && flag[5] == 0 && calculate_distance(robot_point_real, robot_point_target)<=0.1) {
			*start_flag = 0;
			for (i = 0; i < 10; i++)
			{
				flag[i] = 0;
			}
			return 1;
		}
	}
	return 0;
}
uint8 run_PID(
	uint8 x0, uint8 y0,
	uint8 x1, uint8 y1,
	uint8 x2, uint8 y2,
	uint8 x3, uint8 y3,
	uint8 x4, uint8 y4,
	uint8* start_flag)
{
	static uint8 flag[10] = { 0 };
	uint8 i = 0;
	static uint8 temp[5][2] = { 0,0 };

	if (*start_flag == 1) {

		if (
			x0 != temp[0][0] || y0 != temp[0][1] ||
			x1 != temp[1][0] || y1 != temp[1][1] ||
			x2 != temp[2][0] || y2 != temp[2][1] ||
			x3 != temp[3][0] || y3 != temp[3][1] ||
			x4 != temp[4][0] || y4 != temp[4][1]
			) {
			temp[0][0] = x0; temp[0][1] = y0;
			temp[1][0] = x1; temp[1][1] = y1;
			temp[2][0] = x2; temp[2][1] = y2;
			temp[3][0] = x3; temp[3][1] = y3;
			temp[4][0] = x4; temp[4][1] = y4;

			for (i = 0; i < 10; i++)
			{
				flag[i] = 0;
			}
		}

		if (flag[0] == 0) {
			vision_point_RED_target.x = x0;
			vision_point_RED_target.y = y0;
			flag[0] = 1;
		}
		else if (flag[0] == 1 && flag[1] == 0 && calculate_distance(vision_point_RED_target, vision_point_RED) <=5) {
			vision_point_RED_target.x = x1;
			vision_point_RED_target.y = y1;
			flag[1] = 1;
		}
		else if (flag[1] == 1 && flag[2] == 0 && calculate_distance(vision_point_RED_target, vision_point_RED) <=5) {
			vision_point_RED_target.x = x2;
			vision_point_RED_target.y = y2;
			flag[2] = 1;
		}
		else if (flag[2] == 1 && flag[3] == 0 && calculate_distance(vision_point_RED_target, vision_point_RED) <= 5) {
			vision_point_RED_target.x = x3;
			vision_point_RED_target.y = y3;
			flag[3] = 1;
		}
		else if (flag[3] == 1 && flag[4] == 0 && calculate_distance(vision_point_RED_target, vision_point_RED) <= 5) {
			vision_point_RED_target.x = x4;
			vision_point_RED_target.y = y4;
			flag[4] = 1;
		}
		else if (flag[4] == 1 && flag[5] == 0 && calculate_distance(vision_point_RED_target, vision_point_RED) <=5) {
			*start_flag = 0;
			for (i = 0; i < 10; i++)
			{
				flag[i] = 0;
			}
			return 1;
		}
	}
	return 0;
}