#include "pid.h"

//----------------------------------------------------------------------//
// λʽpidʼ
void Pid_Loc_Init(pid_param_t* pid)
{
	pid->kp = 0.0;
	pid->ki = 0.0;
	pid->kd = 0.0;
	pid->error_deadband = 0.0;
	pid->imax = 0.0;
	pid->alpha = 0.0;
	pid->i_line = 0.0;

	pid->d_P = 0.0;
	pid->d_I = 0.0;
	pid->d_D = 0.0;
	pid->out = 0.0;
	pid->integrator = 0.0;
	pid->last_error = 0.0;
	pid->last_last_error = 0.0;
}
// ʽpidʼ
void Pid_Inc_Init(pid_param_t* pid)
{
	pid->kp = 1.0;
	pid->ki = 0.0;
	pid->kd = 0.0;
	pid->error_deadband = 0.0;
	pid->imax = 0.0;
	pid->alpha = 0.0;


	pid->d_P = 0.0;
	pid->d_I = 0.0;
	pid->d_D = 0.0;
	pid->d_out = 0.0;
	pid->out = 0.0;
	pid->last_d_D = 0.0;
	pid->last_error = 0.0;
	pid->last_last_error = 0.0;
}
/*************************************************************************
 *  ƣPidLocCtrl(pid_param_t * pid, float error)
 *  ˵pidλʽ
 *  ˵
 *  @param    pid      pid
 *  @param    target   pidֵ
 *  @param    real     pidʵֵ
 *  أPID
 *  ޸ʱ䣺2023527
 *      ע
 *************************************************************************/
float Pid_Loc(pid_param_t* pid, float error)
{
	if ((pid->error_deadband) && ((error <= pid->error_deadband) && (error >= -pid->error_deadband)))//
	{
		//pid->out = 0.0;
		//pid->d_P = 0.0;
		//pid->d_I = 0.0;
		//pid->d_D = 0.0;
	}
	else
	{
		if (pid->kp)
		{
			pid->d_P = pid->kp * error;
		}
		else
			pid->d_P = 0.0;

		if (pid->ki)//ַ
		{
			if ((pid->i_line == 0.0) || (error <= pid->i_line && error >= -pid->i_line))
			{
				pid->integrator += error;

				pid->d_I = pid->ki * pid->integrator;
			}
		}
		else 
		{
			pid->integrator = 0;
			pid->d_I = 0.0;
		}
		if (pid->kd)//΢Ľ
		{
			if (pid->alpha != 1.0)
				pid->d_D = (pid->kd * (1.0 - pid->alpha) * (error - pid->last_error)) + (pid->alpha * pid->last_d_D);
			else
				pid->d_D = 0;
		}
		else
			pid->d_D = 0.0;

		pid->out = pid->d_P + pid->d_I + pid->d_D;

		if (pid->imax)	//ֱ
		{
			if (pid->out >= pid->imax)
			{
				pid->integrator = 0;
				pid->out = pid->imax;
			}
			else if (pid->out <= -pid->imax)
			{
				pid->integrator = 0;
				pid->out = -pid->imax;
			}
		}
	}

	pid->last_error = error;
	pid->last_d_D = pid->d_D;
	return pid->out;
}
/*************************************************************************
 *  ƣPid_Inc(pid_param_t * pid, float error)
 *  ˵pidʽ
 *  ˵
 *  @param    pid      pid
 *  @param    error		ƫźţTarget-Real//0.00~1.00Ĵֵ
 *  أPID
 *  ޸ʱ䣺2023512
 *      ע
 *************************************************************************/
float Pid_Inc(pid_param_t* pid, float error)
{
	if ((pid->error_deadband) && ((error <= pid->error_deadband) && (error >= -pid->error_deadband)))//
	{
		pid->d_P = 0.0;
		pid->d_I = 0.0;
		pid->d_D = 0.0;
		pid->d_out=0.0;
	}
	else
	{
		if (pid->kp)
			pid->d_P = pid->kp * (error - pid->last_error);
		else
			pid->d_P = 0.0;

		if (pid->ki)
			pid->d_I = pid->ki * error;
		else
			pid->d_I = 0.0;

		if (pid->kd)//΢Ľ
		{
			if (pid->alpha != 1.0)
				pid->d_D = (pid->alpha * pid->last_d_D) + (pid->kd * (1.0 - pid->alpha) * (error - 2.0 * pid->last_error + pid->last_last_error));
			else
				pid->d_D = 0.0;
		}
		else
			pid->d_D = 0.0;

		pid->d_out = pid->d_P + pid->d_I + pid->d_D;//

		pid->out += pid->d_out;//

		if (pid->imax)	//޷
		{
			if (pid->out >= pid->imax)
			{
				pid->out = pid->imax;
			}
			else if (pid->out <= -pid->imax)
			{
				pid->out = -pid->imax;
			}
		}

	}

	pid->last_last_error = pid->last_error;
	pid->last_error = error;
	pid->last_d_D = pid->d_D;
	return pid->out;
}




